function RR_LootWindowEvent()


	ChatFrame1:AddMessage(event)
	ChatFrame1:AddMessage(arg1)
	ChatFrame1:AddMessage(arg2)

	if event == "LOOT_OPENED" then
		player_name = UnitName("player"); 
		mob_name = UnitName("target"); 
		mob_guid = UnitGUID("target");
		ChatFrame1:AddMessage(mob_name.." has the GUID: "..mob_guid);
		
	-- Create an array for the mob GUID
		if RaidRoll_DB["Loot"][mob_guid] == nil then RaidRoll_DB["Loot"][mob_guid] = {} end
		
		
		if RaidRoll_DB["Loot"][mob_guid]["ALREADY FOUND"] == nil then
			
		-- Set it so that we know the mob has been found
			RaidRoll_DB["Loot"][mob_guid]["ALREADY FOUND"] = true
			ChatFrame1:AddMessage("New Mob Found!")
			
		-- Get the number of items on the body
			numLootItems = GetNumLootItems();
			
			LootNumber = 0
			
		-- Check if the mob has loots
			if numLootItems ~= nil then
				ChatFrame1:AddMessage("The Mob Has Loots!")
				ChatFrame1:AddMessage(numLootItems)
				
			-- Used later to see if an item was found yet
				WeHaveFoundAnItem = false
				
			-- Start scanning for items
				for i=1,numLootItems do
				-- If its an item
					if LootSlotIsItem(i) then
						if WeHaveFoundAnItem == false then
						-- If we are currently looking at the last window
							if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] == RaidRoll_DB["Loot"]["CURRENT WINDOW"] then
							--then increment the current window ID
								RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] + 1
							end
							
						-- Add a window to the list of windows
							RaidRoll_DB["Loot"]["TOTAL WINDOWS"] = RaidRoll_DB["Loot"]["TOTAL WINDOWS"] + 1
							Max_LootID = RaidRoll_DB["Loot"]["TOTAL WINDOWS"]
							
							
						-- Set the Identifier to the mob guid
							if RaidRoll_DB["Loot"][Max_LootID] == nil then RaidRoll_DB["Loot"][Max_LootID] = mob_guid end
							
							WeHaveFoundAnItem = true
						end
					
					-- Increase the count by 1 (because an item was found)
						LootNumber = LootNumber + 1
						
					-- Get the ICON and ITEMLINK
						lootIcon, lootName, lootQuantity, rarity = GetLootSlotInfo(i);
						ItemLink = GetLootSlotLink(i); 
						
						
						RaidRoll_DB["Loot"][mob_guid]["LOOTER NAME"] 	= player_name
						RaidRoll_DB["Loot"][mob_guid]["MOB NAME"] 		= mob_name
						RaidRoll_DB["Loot"][mob_guid]["TOTAL ITEMS"] 	= LootNumber
						
						
						if RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber] == nil then RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber] = {} end
						
						RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["ITEMLINK"] 	= ItemLink
						RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["ICON"]		= lootIcon
						RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["WINNER"]		= "-"
						RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["RECEIVED"]	= "-"
						
						
						ChatFrame1:AddMessage(ItemLink)
						
						ChatFrame1:AddMessage(lootIcon)
						ChatFrame1:AddMessage(lootName)
						ChatFrame1:AddMessage(lootQuantity)
						ChatFrame1:AddMessage(rarity)	
						
						RR_Loot_Display_Refresh()						
					end
				end
			end	
		end
	end
end


-- sets up the loot frame
function RR_SetupLootFrame()

--Clear the database (debugging)
--RaidRoll_DB["Loot"] = {}

if RaidRoll_DB["Loot"] == nil then RaidRoll_DB["Loot"] = {} end
if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] == nil then RaidRoll_DB["Loot"]["TOTAL WINDOWS"] = 0 end
if RaidRoll_DB["Loot"]["CURRENT WINDOW"] == nil then RaidRoll_DB["Loot"]["CURRENT WINDOW"] = 0 end





-- Hook Looting events
 local RR_LootEventHook = CreateFrame("Frame")
 
  RR_LootEventHook:RegisterEvent("LOOT_OPENED")
  
 RR_LootEventHook:SetScript("OnEvent", RR_LootWindowEvent)
  
  
  
  

RR_LOOT_FRAME = CreateFrame("Frame","RR_LOOT_FRAME",UIParent)

rr_default_backdrop = {
  --bgFile="Interface\DialogFrame\UI-DialogBox-Background",  -- path to the background texture
  --edgeFile="Interface\DialogFrame\UI-DialogBox-Border",  -- path to the border texture
  
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  -- path to the background texture
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",  -- path to the border texture
  
  tile = true,    -- true to repeat the background texture to fill the frame, false to scale it
  tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
    left = 2,
    right = 2,
    top = 2,
    bottom = 2
  }
}

RR_LOOT_FRAME:SetBackdrop(rr_default_backdrop)




RR_LOOT_FRAME:SetFrameStrata("DIALOG")
RR_LOOT_FRAME:SetWidth(260) -- Set these to whatever height/width is needed 
RR_LOOT_FRAME:SetHeight(270) -- Set these to whatever height/width is needed 
	

RR_LOOT_FRAME:ClearAllPoints(); 
RR_LOOT_FRAME:SetPoint("CENTER", UIParent, "CENTER", 0, 0)

RR_LOOT_FRAME:Show()

RR_LOOT_FRAME:SetMovable(true)
RR_LOOT_FRAME:EnableMouse(true)
RR_LOOT_FRAME:SetScript("OnMouseDown",function()
  RR_LOOT_FRAME:StartMoving()
end)
RR_LOOT_FRAME:SetScript("OnMouseUp",function()
  RR_LOOT_FRAME:StopMovingOrSizing()
end)

ChatFrame1:AddMessage("Loot Frame - Loaded")

if RR_LOOT_FRAME:IsShown() then
	ChatFrame1:AddMessage("Loot Frame - Shown")
end





-- Create 5 strings and a header for the guild ranks
	Raid_Roll_Loot=CreateFrame("FRAME","Raid_Roll_Loot",RR_LOOT_FRAME);
	
	RR_Loot_String_WindowName = Raid_Roll_Loot:CreateFontString("Window Name","ARTWORK","GameFontNormal");
	RR_Loot_String_WindowName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -8);
	RR_Loot_String_WindowName:SetJustifyH("LEFT")
	RR_Loot_String_WindowName:SetText("Killerpet's Loot Tracking Window")
	
	RR_Loot_String_MobName = Raid_Roll_Loot:CreateFontString("Mob Name","ARTWORK","GameFontNormal");
	RR_Loot_String_MobName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -210);
	RR_Loot_String_MobName:SetJustifyH("LEFT")
	RR_Loot_String_MobName:SetText("Mob Name:")
	
	RR_Loot_String_LooterName = Raid_Roll_Loot:CreateFontString("Looter Name","ARTWORK","GameFontNormal");
	RR_Loot_String_LooterName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -230);
	RR_Loot_String_LooterName:SetJustifyH("LEFT")
	RR_Loot_String_LooterName:SetText("Looter Name:")
	
--------------------THE BUTTONS   [<<] [<]   [>] [>>]--------------------
	RR_Loot_Button = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_Button:SetWidth(40)
	RR_Loot_Button:SetHeight(20)
	RR_Loot_Button:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 5, 5)
	RR_Loot_Button:SetText("<<")
	RR_Loot_Button:SetScript("OnClick",function() RR_Loot_GotoWindow("First") end)
	
	RR_Loot_Button = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_Button:SetWidth(40)
	RR_Loot_Button:SetHeight(20)
	RR_Loot_Button:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 50, 5)
	RR_Loot_Button:SetText("<")
	RR_Loot_Button:SetScript("OnClick",function() RR_Loot_GotoWindow("Prev") end)
	
	RR_Loot_Button = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_Button:SetWidth(40)
	RR_Loot_Button:SetHeight(20)
	RR_Loot_Button:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 105, 5)
	RR_Loot_Button:SetText(">")
	RR_Loot_Button:SetScript("OnClick",function() RR_Loot_GotoWindow("Next") end)
	
	RR_Loot_Button = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_Button:SetWidth(40)
	RR_Loot_Button:SetHeight(20)
	RR_Loot_Button:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 150, 5)
	RR_Loot_Button:SetText(">>")
	RR_Loot_Button:SetScript("OnClick",function() RR_Loot_GotoWindow("Last") end)
	
	
--------------------THE SLIDER BAR--------------------------------

 RaidRoll_Loot_Slider = CreateFrame("Slider", "RaidRoll_Loot_Slider_ID", RR_LOOT_FRAME, "OptionsSliderTemplate")
 RaidRoll_Loot_Slider:SetWidth(10)
 RaidRoll_Loot_Slider:SetHeight(RR_LOOT_FRAME:GetHeight() - 30 )
 RaidRoll_Loot_Slider:SetPoint('TOPRIGHT', -8, -25)
 RaidRoll_Loot_Slider:SetOrientation('VERTICAL')
 

 getglobal(RaidRoll_Loot_Slider:GetName() .. 'Low'):SetText('');
 getglobal(RaidRoll_Loot_Slider:GetName() .. 'High'):SetText(''); 
 getglobal(RaidRoll_Loot_Slider:GetName() .. 'Text'):SetText('');


 
 RaidRoll_Loot_Slider:SetMinMaxValues(1, 1)
 RaidRoll_Loot_Slider:SetValueStep(1)
 RaidRoll_Loot_Slider:SetValue(1)

 RaidRoll_Loot_Slider:Show()
 
 
  RaidRoll_Loot_Slider:SetScript("OnValueChanged",function()
	RaidRoll_Loot_Slider_Window_Scroll(0)
  end)
 
 ----------------------------------------------------
 
 -- This allows scrolling and passes arg1 (the direction of the scrolling [1 or -1] )
RR_LOOT_FRAME:EnableMouseWheel(1)
 RR_LOOT_FRAME:SetScript("OnMouseWheel",function()
  RaidRoll_Loot_Slider_Window_Scroll(arg1)
end)

-------------------------------------------------------------

 Close_Button = CreateFrame("Button", "Close_Button", RR_LOOT_FRAME, "UIPanelCloseButton")
 Close_Button:SetWidth(30)
 Close_Button:SetHeight(30)
 Close_Button:SetPoint("TOPRIGHT", RR_LOOT_FRAME, "TOPRIGHT", -0, -0)

--------------------------------------------------------------------------------------------------------
	
	-- Create frames which will be used for items
	for i=1,4 do
		RR_Loot_Name_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Name_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Name_String_i:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 45, 20 - (i*45));
		RR_Loot_Name_String_i:SetJustifyH("LEFT")
		RR_Loot_Name_String_i:SetWidth(200); 
		RR_Loot_Name_String_i:SetText("Item "..i)
		
		RR_Loot_Won_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Won_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Won_String_i:SetPoint("TOPLEFT",RR_Loot_Name_String_i,"TOPLEFT", 0, -12);
		RR_Loot_Won_String_i:SetJustifyH("LEFT")
		RR_Loot_Won_String_i:SetWidth(200); 
		RR_Loot_Won_String_i:SetText("Won Item: "..i)
		
		RR_Loot_Received_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Received_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Received_String_i:SetPoint("TOPLEFT",RR_Loot_Won_String_i,"TOPLEFT", 0, -12);
		RR_Loot_Received_String_i:SetJustifyH("LEFT")
		RR_Loot_Received_String_i:SetWidth(200); 
		RR_Loot_Received_String_i:SetText("Received: "..i)
		
		RR_LootIcon = CreateFrame("Button","RR_LootIcon"..i,RR_LOOT_FRAME)
		--RR_LootIcon:SetFrameStrata("FULLSCREEN")
		RR_LootIcon:SetWidth(40) -- Set these to whatever height/width is needed 
		RR_LootIcon:SetHeight(40) -- Set these to whatever height/width is needed 
		--RR_LootIcon:ClearAllPoints(); 
		RR_LootIcon:SetPoint("TopLeft", "RR_LOOT_FRAME", "TopLeft", 5, 20 - (i*45))
		RR_LootIcon:SetBackdrop(rr_default_backdrop)
		--RR_LootIcon:Show()
		
		RR_LootIcon:SetScript("OnEnter", function(self) RR_MouseOver(self:GetName())	end)
		RR_LootIcon:SetScript("OnLeave", function() GameTooltip:Hide()	end)
	end	
	
	RR_Loot_CurrentVsMaxWindow = Raid_Roll_Loot:CreateFontString("RR_Loot_CurrentVsMaxWindow_String" ,"ARTWORK","GameFontNormal");
	RR_Loot_CurrentVsMaxWindow:SetPoint("BottomLEFT",RR_LOOT_FRAME,"BottomLEFT", 200, 10);
	RR_Loot_CurrentVsMaxWindow:SetJustifyH("LEFT")
	RR_Loot_CurrentVsMaxWindow:SetWidth(60); 
	RR_Loot_CurrentVsMaxWindow:SetText("0/0")

	RR_Loot_Display_Refresh()
end

function RR_Loot_GotoWindow(WhichWindow)

	ChatFrame1:AddMessage("Current:")
	ChatFrame1:AddMessage(RaidRoll_DB["Loot"]["CURRENT WINDOW"])
	ChatFrame1:AddMessage("Total:")
	ChatFrame1:AddMessage(RaidRoll_DB["Loot"]["TOTAL WINDOWS"])

	if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] ~= 0 then
		if WhichWindow == "First" then
			RaidRoll_DB["Loot"]["CURRENT WINDOW"] = 1
		elseif WhichWindow == "Prev" then
			if RaidRoll_DB["Loot"]["CURRENT WINDOW"] > 1 then
				RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] - 1
			end
		elseif WhichWindow == "Next" then
			if RaidRoll_DB["Loot"]["CURRENT WINDOW"] < RaidRoll_DB["Loot"]["TOTAL WINDOWS"] then
				RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] + 1
			end
		elseif WhichWindow == "Last" then
			RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["TOTAL WINDOWS"]
		end
	end
	
	RR_Loot_Display_Refresh()
end


-- Come back to this
function RaidRoll_Loot_Slider_Window_Scroll(direction)

	if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] ~= 0 then
		-- Debugging, shows the direction and value
		if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(direction) end
		if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(RaidRoll_Loot_Slider:GetValue()) end
		
		if RaidRoll_DB[RaidRoll_DB["CurrentLootID"]]["MaxItems"] >= 4 then
			Loot_MaxNumber = RaidRoll_DB[RaidRoll_DB["CurrentLootID"]]["MaxItems"]-3
		else
			Loot_MaxNumber = 1
		end
		
		RaidRoll_Loot_Slider:SetMinMaxValues(1, Loot_MaxNumber)
		
		
		RaidRoll_Loot_Slider:SetValue(RaidRoll_Loot_Slider:GetValue() - (direction * 2))
		
		if RaidRoll_Loot_Slider:GetValue() > Loot_MaxNumber then
			RaidRoll_Loot_Slider:SetValue(Loot_MaxNumber)
		end
		
		RR_ScrollOffset = RaidRoll_Loot_Slider:GetValue() - 1
	 
		RR_Loot_Display_Refresh()
	end
end


function RR_Loot_Display_Refresh()

Current_Window = RaidRoll_DB["Loot"]["CURRENT WINDOW"]

	if Current_Window ~= 0 then
	--Get the mob id for the current window
		MOB_ID = RaidRoll_DB["Loot"][Current_Window]

		for i=1,4 do
			if i <= RaidRoll_DB["Loot"][MOB_ID]["TOTAL ITEMS"] then
				
				MobName		= RaidRoll_DB["Loot"][MOB_ID]["MOB NAME"]
				LooterName	= RaidRoll_DB["Loot"][MOB_ID]["LOOTER NAME"]
				
				ItemLink 	= RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..i]["ITEMLINK"]
				ItemIcon 	= RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..i]["ICON"]
				Winner 		= RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..i]["WINNER"]
				Received 	= RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..i]["RECEIVED"]
				
				
				getglobal("RR_Loot_Name_String"..i):SetText(ItemLink)
				getglobal("RR_LootIcon"..i):SetBackdrop( {bgFile = ItemIcon	})
				getglobal("RR_Loot_Won_String"..i):SetText("Won Item: " .. Winner)
				getglobal("RR_Loot_Received_String"..i):SetText("Received: " .. Received)
				
				RR_Loot_String_MobName:SetText("Mob Name: ".. MobName)
				RR_Loot_String_LooterName:SetText("Looter Name: ".. LooterName)
				
				RR_Loot_CurrentVsMaxWindow:SetText(RaidRoll_DB["Loot"]["CURRENT WINDOW"].."/"..RaidRoll_DB["Loot"]["TOTAL WINDOWS"])
			else
				getglobal("RR_Loot_Name_String"..i):SetText("")
				getglobal("RR_LootIcon"..i):SetBackdrop(rr_default_backdrop)
				getglobal("RR_Loot_Won_String"..i):SetText("Won Item: ")
				getglobal("RR_Loot_Received_String"..i):SetText("Received: ")
				
			end
		end
	end
end

function RR_MouseOver(ID)

	--ChatFrame1:AddMessage(ID)

	if ID == "RR_LootIcon1" then i = 1 end
	if ID == "RR_LootIcon2" then i = 2 end
	if ID == "RR_LootIcon3" then i = 3 end
	if ID == "RR_LootIcon4" then i = 4 end

	Current_Window = RaidRoll_DB["Loot"]["CURRENT WINDOW"]
	MOB_ID = RaidRoll_DB["Loot"][Current_Window]

	GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
	GameTooltip:ClearAllPoints(); 
	GameTooltip:SetPoint("bottomleft", getglobal(ID), "topright", 0, 0)
	GameTooltip:ClearLines()
	
	if RaidRoll_DB["Loot"][MOB_ID] ~= nil then
		if RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..i] ~= nil then
			GameTooltip:SetHyperlink(RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..i]["ITEMLINK"])
		end
	end
	
end
